
// -- DIST ACTIONS -- //

void distAction(uint8_t _distState) {
  
  Serial << "dist state: " << _distState << endl;
  
  switch(_distState) {
    case 0: {
      // really close
      
      for(uint8_t i=0; i<2; i++) {
      
        for(uint8_t j=0; j<3; j++) {
          servo[i].write(homePos[i]-30);
          servo[i+1].write(homePos[i+1]-30);
          delay(50);
          servo[i].write(homePos[i]+30);
          servo[i+1].write(homePos[i+1]+30);
          delay(50);
        }
        
        servo[0].write(homePos[i]-30);
        servo[3].write(homePos[i+1]-30);
        delay(50);
        servo[0].write(homePos[i]+30);
        servo[3].write(homePos[i+1]+30);
        delay(50);
        
      }
      
      uint8_t chosenServo = (uint8_t)random(0, 4);
      
      for(uint8_t i=0; i<2; i++) {
        for(uint8_t j=0; j<4; j++) {
          servo[j].write(homePos[j]+posdiff);
          delay(150);
          servo[j].write(homePos[j]-posdiff);
          delay(150);
        }
      }
      
      for(uint8_t j=0; j<4; j++) {
        servo[j].write(homePos[j]);
        delay(100);
      }
      
    }
    break;
    case 1: {
      // close
      
      uint8_t chosenServo = (uint8_t)random(0, 4);
      
      for(uint8_t i=0; i<2; i++) {
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        delay(150);
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        delay(150);
      }
      
      servo[chosenServo].write(homePos[chosenServo]);
      
      chosenServo = (uint8_t)random(0, 4);
      
      for(uint8_t i=0; i<4; i++) {
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        delay(150);
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        delay(150);
      }
      
      servo[chosenServo].write(homePos[chosenServo]);
      
    }
    break;
    case 2: {
      // medium
      
      for(uint8_t j=0; j<3; j++) {
      
        for(uint8_t i=0; i<4; i++) {
          servo[i].write(homePos[i]+posdiff);
          delay(100);
        }
        delay(150);
      
        for(uint8_t i=0; i<4; i++) {
          servo[i].write(homePos[i]-posdiff);
          delay(100);
        }
        delay(150);
      
      }
      
      for(uint8_t i=0; i<4; i++) {
        servo[i].write(homePos[i]+posdiff);
        delay(100);
      }
      
    }
    break;
    case 3: {
      // almost far
      
      uint8_t chosenServo = (uint8_t)random(0, 4);
      
      for(uint8_t i=0; i<2; i++) {
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        delay(250);
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        delay(250);
      }
      
      for(uint8_t i=0; i<3; i++) {
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        delay(100);
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        delay(100);
      }
      
      servo[chosenServo].write(homePos[chosenServo]);
      
    }
    break;
    case 4: {
      // far
      
      uint8_t chosenServo = (uint8_t)random(0, 4);
      uint8_t secondServo = (uint8_t)random(0, 4);
      
      while(chosenServo == secondServo) {
        secondServo = (uint8_t)random(0, 4);
      }
      
      for(uint8_t i=0; i<4; i++) {
        
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        
        for(uint8_t j=0; j<3; j++) {
          servo[secondServo].write(homePos[secondServo]+30);
          delay(100);
          servo[secondServo].write(homePos[secondServo]-30);
          delay(100);
        }
        
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        
        for(uint8_t j=0; j<3; j++) {
          servo[secondServo].write(homePos[secondServo]+30);
          delay(100);
          servo[secondServo].write(homePos[secondServo]-30);
          delay(100);
        }
        
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        
      }
      
      servo[chosenServo].write(homePos[chosenServo]);
      servo[secondServo].write(homePos[secondServo]);
      
    }
    break;
    case 5: {
      // really far
      uint8_t chosenServo = (uint8_t)random(0, 4);
      
      for(uint8_t i=0; i<4; i++) {
        servo[chosenServo].write(homePos[chosenServo]+posdiff);
        delay(300);
        servo[chosenServo].write(homePos[chosenServo]-posdiff);
        delay(300);
      }
      
      servo[chosenServo].write(homePos[chosenServo]);
      
    }
    break;
  }
  
}

void distActionTest() {
  
  Serial << "really close" << endl;
  distAction(0);
  delay(2000);
  
  Serial << "close" << endl;
  distAction(1);
  delay(2000);
  
  Serial << "medium" << endl; // favourite, goes in a circle
  distAction(2);
  delay(2000);
  
  Serial << "almost far" << endl;
  distAction(3);
  delay(2000);
  
  Serial << "far" << endl;
  distAction(4);
  delay(2000);
  
  Serial << "really far" << endl; // another favourite, swings back & forth but it can really move!!
  distAction(5);
  delay(2000);
  
}



// -- DIST BEHAVIOUR -- //

void distBehaviour() {
 
 
  for(uint8_t i=0; i<4; i++) {
    squareOn();
    delay(200);
    squareOff();
    delay(200);
  }
  squareOn();
  delay(400);
  
  uint8_t dist = readDistance();
  
  if(dist <= 15) {
    Serial << "really close" << endl;
    distState = 0;
  } else if(dist > 15 && dist <= 20) {
    Serial << "close" << endl;
    distState = 1;
  } else if(dist > 20 && dist <= 25) {
    Serial << "medium" << endl;
    distState = 2;
  } else if(dist > 25 && dist <= 30) {
    Serial << "almost far" << endl;
    distState = 3;
  } else if(dist > 30 && dist <= 40) {
    Serial << "far" << endl;
    distState = 4;
  } else {
    Serial << "really far" << endl;
    distState = 5;
  }
  
  squareOff();
  
  
  switch(distState) {
    case 0:
      if(distState_prev != 0 && distState_prev != 1) {
        Serial << "We are really close now!" << endl;
        beExcited();
      } else {
        Serial << "Oh! What is going on here?!" << endl;
        beSurprised();
      }
      distAction(distState);
    break;
    case 1:
      if(distState_prev != 1 && distState_prev != 2) {
        if(distState_prev < distState) {
          Serial << "Glad you backed up a little bit there..." << endl;
          beRelieved();
        } else {
          Serial << "I can sense you much more closely now!" << endl;
          bePleased();
        }
      } else {
        Serial << "Oh! What is going on here?!" << endl;
        beSurprised();
      }
      distAction(distState);
    break;
    case 2:
      if(distState_prev != 2 && distState_prev != 3) {
        if(distState_prev < distState) {
          Serial << "You backed up a little? Was it too close?" << endl;
          beConfused();
        } else {
          Serial << "We're a good distance between each other. Medium." << endl;
          beContent();
        }
      } else {
        Serial << "Oh! What is going on here?!" << endl;
        beSurprised();
      }
      distAction(distState);
    break;
    case 3:
      if(distState_prev != 3 && distState_prev != 4) {
        if(distState_prev < distState) {
          Serial << "You are getting almost far away right now..." << endl;
          beDiscontent();
        } else {
          Serial << "Excellent! Come closer! Come closer! Heeheehee" << endl;
          bePleased();
        }
      } else {
        Serial << "Oh! What is going on here?!" << endl;
        beSurprised();
      }
      distAction(distState);
    break;
    case 4:
      if(distState_prev != 4 && distState_prev != 5) {
        if(distState_prev < distState) {
          Serial << "Oh, I guess we are farther away now... okay." << endl;
          beDiscontent();
        } else {
          Serial << "Why hello there human or something!" << endl;
          beContent();
        }
      } else {
        Serial << "Oh! What is going on here?!" << endl;
        beSurprised();
      }
      distAction(distState);
    break;
    case 5:
      if(distState_prev != 5) {
        Serial << "It's so hard to say goodbye... not. GOODBYE!" << endl;
        beAngry();
      } else {
        Serial << "I wonder if I will ever meet a human in my lifetime..." << endl;
        beWondering();
      }
      distAction(distState);
    break;
  }
  
}


