void squareColour(uint8_t led, uint8_t col, boolean beOn) {
 
  if(beOn) {
    ShiftPWM.SetOne((led*3)+col, 255);
    squareLeds[led][col] = 255;
  } else {
    ShiftPWM.SetOne((led*3)+col, 0);
    squareLeds[led][col] = 0;
  }
  
}

void squareOff() {
  
  for(uint8_t i=0; i<12; i++) {
    ShiftPWM.SetOne(i, 0);
  }
  
  for(uint8_t j=0; j<4; j++) {
    for(uint8_t i=0; i<3; i++) {
      squareLeds[j][i] = 0;
    }
  }
  
}

void squareOn() {
  
  for(uint8_t i=0; i<12; i++) {
    ShiftPWM.SetOne(i, 255);
  }
  
  for(uint8_t j=0; j<4; j++) {
    for(uint8_t i=0; i<3; i++) {
      squareLeds[j][i] = 255;
    }
  }
  
}


void updateSquareRainbow() {
  
  lastSquareRainbow++;
  if(lastSquareRainbow > 6) lastSquareRainbow = 0;
  
  ShiftPWM.SetAll(0);
  
  switch(lastSquareRainbow) {
    case 0: // R  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(i*3, 255);
      squareLeds[i][0] = 255;
      squareLeds[i][1] = 0;
      squareLeds[i][2] = 0;
    }
    
    break;
    case 1: // RG  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(i*3, 255);
      ShiftPWM.SetOne(((i+1)*3)-2, 255);
      squareLeds[i][0] = 255;
      squareLeds[i][1] = 255;
      squareLeds[i][2] = 0;
    }
    
    break;
    case 2: // G  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(((i+1)*3)-2, 255);
      squareLeds[i][0] = 0;
      squareLeds[i][1] = 255;
      squareLeds[i][2] = 0;
    }
    
    break;
    case 3: // GB  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(((i+1)*3)-2, 255);
      ShiftPWM.SetOne(((i+1)*3)-1, 255);
      squareLeds[i][0] = 0;
      squareLeds[i][1] = 255;
      squareLeds[i][2] = 255;
    }
    
    break;
    case 4: // B  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(((i+1)*3)-1, 255);
      squareLeds[i][0] = 0;
      squareLeds[i][1] = 0;
      squareLeds[i][2] = 255;
    }
    
    break;
    case 5: // BR  
    
    for(uint8_t i=0; i<4; i++) {
      ShiftPWM.SetOne(i*3, 255);
      ShiftPWM.SetOne(((i+1)*3)-1, 255);
      squareLeds[i][0] = 255;
      squareLeds[i][1] = 0;
      squareLeds[i][2] = 255;
    }
    
    break;
  }
  
  millisSquareRainbow = millis();
  
}


void fadeSquare(uint8_t toVal, uint8_t stepTime) {
  
  Serial << "fade to: " << toVal << endl;
  
  uint8_t skipEvery[4][3];
  
  for(uint8_t i=0; i<4; i++) {
    for(uint8_t j=0; j<3; j++) {
      skipEvery[i][j] = 255/abs(squareLeds[i][j]-toVal);
    }
  }
  
  for(uint8_t i=0; i<255; i++) {
  
    for(uint8_t ii=0; ii<4; ii++) {
      
    for(uint8_t jj=0; jj<3; jj++) {
    
      if(squareLeds[ii][jj] < toVal) {
        
        if(i <= toVal) {
          if(i % skipEvery[ii][jj] == 0) {
            ShiftPWM.SetOne((ii*3)+jj, i);
          }
        }
        
      } else if(squareLeds[ii][jj] > toVal) {
         
        if(i <= (255-toVal)) {
          if(i % skipEvery[ii][jj] == 0) {
            ShiftPWM.SetOne((ii*3)+jj, 255-i);
          }
        }
        
      }
     
    }
    
    }
    
    delay(stepTime);
    
  }
  
  
  for(uint8_t i=0; i<4; i++) {
    for(uint8_t j=0; j<3; j++) {
      ShiftPWM.SetOne((i*3)+j, toVal);
      squareLeds[i][j] = toVal;
    }
  }
  Serial << "done fade" << endl;
  
}



void fadeSquareLed(uint8_t led, uint8_t col, uint8_t toVal, uint8_t stepTime) {
  
  Serial << "fade to: " << toVal << endl;
  
  uint8_t skipEvery = 255/abs(squareLeds[led][col]-toVal);
  
  for(uint8_t i=0; i<255; i++) {
  
    if(squareLeds[led][col] < toVal) {
      
      if(i <= toVal) {
        if(i % skipEvery == 0) ShiftPWM.SetOne((led*3)+col, i);
      }
      
    } else if(squareLeds[led][col] > toVal) {
       
      if(i <= (255-toVal)) {
        if(i % skipEvery == 0) ShiftPWM.SetOne((led*3)+col, 255-i);
      }
      
    }
    
    delay(stepTime);
    
  }

  ShiftPWM.SetOne((led*3)+col, toVal);
  squareLeds[led][col] = toVal;
  Serial << "done fade" << endl;
  
}


void allSquareLeds(uint8_t r, uint8_t g, uint8_t b, uint8_t stepTime) {
  
  //Serial << "fade to: " << toVal << endl;
  
  uint8_t toVal = 0;
  uint8_t skipEvery[4][3];
  
  for(uint8_t i=0; i<4; i++) {
      skipEvery[i][0] = 255/abs(squareLeds[i][0]-r);
      skipEvery[i][1] = 255/abs(squareLeds[i][0]-g);
      skipEvery[i][2] = 255/abs(squareLeds[i][0]-b);
  }
  
  for(uint8_t i=0; i<255; i++) {
  
    for(uint8_t ii=0; ii<4; ii++) {
      
    for(uint8_t jj=0; jj<3; jj++) {
    
      if(jj == 0) {
        toVal = r;
      } else if(jj == 1) {
        toVal = g;
      } else if(jj == 2) {
        toVal = b;
      }
      
      if(squareLeds[ii][jj] < toVal) {
        
        if(i <= toVal) {
          if(i % skipEvery[ii][jj] == 0) {
            ShiftPWM.SetOne((ii*3)+jj, i);
          }
        }
        
      } else if(squareLeds[ii][jj] > toVal) {
         
        if(i <= (255-toVal)) {
          if(i % skipEvery[ii][jj] == 0) {
            ShiftPWM.SetOne((ii*3)+jj, 255-i);
          }
        }
        
      }
     
    }
    
    }
    
    delay(stepTime);
    
  }
  
  
  for(uint8_t i=0; i<4; i++) {
    ShiftPWM.SetOne((i*3)+0, r);
    ShiftPWM.SetOne((i*3)+1, g);
    ShiftPWM.SetOne((i*3)+2, b);
    squareLeds[i][0] = r;
    squareLeds[i][1] = g;
    squareLeds[i][2] = b;
  }
  Serial << "done fade" << endl;
  
}


void fadeSquareLeds(uint8_t col, uint8_t toVal, uint8_t stepTime) {
  
  Serial << "fade to: " << toVal << endl;
  
  uint8_t skipEvery[4];
 
  for(uint8_t i=0; i<4; i++) {
    skipEvery[i] = 255/abs(squareLeds[i][col]-toVal);
  }
 
  for(uint8_t i=0; i<255; i++) {
  
    for(uint8_t j=0; j<4; j++) {
    
    if(squareLeds[j][col] < toVal) {
      
      if(i <= toVal) {
        if(i % skipEvery[j] == 0) ShiftPWM.SetOne((j*3)+col, i);
      }
      
    } else if(squareLeds[j][col] > toVal) {
       
      if(i <= (255-toVal)) {
        if(i % skipEvery[j] == 0) ShiftPWM.SetOne((j*3)+col, 255-i);
      }
      
    }
    
    }
    
    delay(stepTime);
    
  }

  for(uint8_t j=0; j<4; j++) {
    ShiftPWM.SetOne((j*3)+col, toVal);
    squareLeds[j][col] = toVal;
  }
  Serial << "done fade" << endl;
  
}



