/*
 * Tentacle Kit Code
 * -----------------
 * robobrrd.com/tentacle
 *
 * Here is the code to get your Tentacle Kit up and wiggling!
 */

// -- SHIFT OUT VARS -- // (do not change)
#define SHIFTPWM_USE_TIMER2
const int ShiftPWM_latchPin = 8;
const bool ShiftPWM_invertOutputs = false;
const bool ShiftPWM_balanceLoad = false;
// -- //

#include <ShiftPWM.h>
#include <Streaming.h>
#include <Servo.h>


#define SERVOQTY 4
#define LEDQTY 6

// -- LEDs -- //
uint8_t tailLed1 = 6;
uint8_t tailLed2 = 5;
uint8_t squareLeds[4][3];
uint8_t lastSquareRainbow = 0;
long millisSquareRainbow = 0;
uint8_t freqSquareRainbow = 500;
uint8_t ledVals[] = {0, 0, 0, 0, 0, 0};


// -- SERVOS -- //
Servo servo[SERVOQTY];
uint8_t servoPin[] = {4, 10, 9, 7};
uint16_t homePos[] = {90, 90, 90, 90};
uint16_t posdiff = 30;

uint8_t servonum = 0;
uint16_t currentPos[] = {0, 0, 0, 0};
uint16_t startPos[] = {0, 0, 0, 0};
uint16_t finalPos[] = {0, 0, 0, 0};
boolean movingServo[] = {false, false, false, false};
uint8_t jumpVal[] = {0, 0, 0, 0};


// -- SHIFT OUT VARS -- // (do not change)
unsigned char maxBrightness = 255;
unsigned char pwmFrequency = 75;
unsigned int numRegisters = 2;
unsigned int numOutputs = numRegisters*8;
unsigned int numRGBLeds = numRegisters*8/3;
unsigned int fadingMode = 0;

// -- DISTANCE -- //
uint8_t distState = 0;
uint8_t distState_prev = 0;
uint8_t pingPin = A0;


// -- //


void setup() {
  
  Serial.begin(9600);
  Serial << "WoOooOoOoOoOoOoo Tentacle Mechanism" << endl;


  // -- leds
  for(uint8_t i=0; i<4; i++) {
    for(uint8_t j=0; j<3; j++) {
      squareLeds[i][j] = 0;
    }
  }

  ShiftPWM.SetAmountOfRegisters(numRegisters);
  ShiftPWM.SetPinGrouping(1);
  ShiftPWM.Start(pwmFrequency,maxBrightness);
  pinMode(tailLed1, OUTPUT);
  pinMode(tailLed2, OUTPUT);
  // --
  
  // -- servos
  for(uint8_t i=0; i<SERVOQTY; i++) {
    servo[i].attach(servoPin[i]);
    servo[i].write(homePos[i]);
  }
  // --
  
}

void loop() {
  
  beExcited();

  for(uint8_t i=0; i<4; i++) {
    wiggle(i, 4, 50);
  }
  
  chaseTentacle(5, 500);
  
  tentacleOn();
  
  
  allSquareLeds(100, 0, 100, 1);
  delay(100);
  allSquareLeds(0, 100, 100, 1);
  delay(100);
  allSquareLeds(100, 100, 0, 1);
  delay(100);
  
  
  fadeTentacleLed(0, 200, 1);
  delay(100);
  fadeTentacleLed(1, 160, 1);
  delay(100);
  fadeTentacleLed(2, 120, 1);
  delay(100);
  fadeTentacleLed(3, 80, 1);
  delay(100);
  fadeTentacleLed(4, 40, 1);
  delay(100);
  fadeTentacleLed(5, 5, 1);
  delay(100);

}



