void blinkTentacle(uint8_t rep, uint8_t del) {
 
  for(uint8_t j=0; j<rep; j++) {
  
    tentacleOff();
    delay(del);
     
    tentacleOn();
    delay(del);
 
  }
  
}

void chaseTentacle(uint8_t rep, uint8_t del) {

  uint8_t lit = -1;
  boolean dir = false;
  uint8_t r = 0;
  
  while(r < rep) {

     if(!dir) {
     lit++;
       if(lit == 5) {
         dir = !dir;
         r++; 
       }
     } else {
     lit--;
       if(lit == 0) {
         dir = !dir;
         r++;
       }
     }
  
    for(uint8_t i=0; i<LEDQTY; i++) {
      if(lit == i) {
        
        if(i < LEDQTY-2) {
          ShiftPWM.SetOne(i+12, 255);
        } else if(i == LEDQTY-2) {
          analogWrite(tailLed1, 255);
        } else if(i == LEDQTY-1) {
          analogWrite(tailLed2, 255);
        }
        
        ledVals[i] = 255;
      } else {
        
        if(i < LEDQTY-2) {
          ShiftPWM.SetOne(i+12, 0);
        } else if(i == LEDQTY-2) {
          analogWrite(tailLed1, 0);
        } else if(i == LEDQTY-1) {
          analogWrite(tailLed2, 0);
        }
        
        ledVals[i] = 0;
      }
    }
 
   delay(del);
  }
  
}

void fadeTentacle(uint8_t toVal, uint8_t stepTime) {
  
  Serial << "fade to: " << toVal << endl;
  
  uint8_t skipEvery[LEDQTY];
  
  for(uint8_t i=0; i<LEDQTY; i++) {
    skipEvery[i] = 255/abs(ledVals[i]-toVal);
  }
  
  for(uint8_t i=0; i<255; i++) {
  
    for(uint8_t j=0; j<LEDQTY; j++) {
    
      if(ledVals[j] < toVal) {
        
        if(i <= toVal) {
          if(i % skipEvery[j] == 0) {
            if(j < LEDQTY-2) {
              ShiftPWM.SetOne(j+12, i);
            } else if(j == LEDQTY-2) {
              analogWrite(tailLed1, i);
            } else if(j == LEDQTY-1) {
              analogWrite(tailLed2, i);
            }
          }
        }
        
      } else if(ledVals[j] > toVal) {
         
        if(i <= (255-toVal)) {
          if(i % skipEvery[j] == 0) {
            if(j < LEDQTY-2) {
              ShiftPWM.SetOne(j+12, 255-i);
            } else if(j == LEDQTY-2) {
              analogWrite(tailLed1, 255-i);
            } else if(j == LEDQTY-1) {
              analogWrite(tailLed2, 255-i);
            }
          }
        }
        
      }
      
    }
    
    delay(stepTime);
    
  }
  
  for(uint8_t i=0; i<LEDQTY; i++) {
    
    if(i < LEDQTY-2) {
      ShiftPWM.SetOne(i+12, toVal);
    } else if(i == LEDQTY-2) {
      analogWrite(tailLed1, toVal);
    } else if(i == LEDQTY-1) {
      analogWrite(tailLed2, toVal);
    }
    
    ledVals[i] = toVal;
  }
  Serial << "done fade" << endl;
  
}

void tentacleOn() {
  
  for(uint8_t i=0; i<LEDQTY; i++) {
    
    if(i < LEDQTY-2) {
      ShiftPWM.SetOne(i+12, 255);
    } else if(i == LEDQTY-2) {
      analogWrite(tailLed1, 255);
    } else if(i == LEDQTY-1) {
      analogWrite(tailLed2, 255);
    }
    
    ledVals[i] = 255;
  }
  
}

void tentacleOff() {
  
  for(uint8_t i=0; i<LEDQTY; i++) {
    
    if(i < LEDQTY-2) {
      ShiftPWM.SetOne(i+12, 0);
    } else if(i == LEDQTY-2) {
      analogWrite(tailLed1, 0);
    } else if(i == LEDQTY-1) {
      analogWrite(tailLed2, 0);
    }
    
    ledVals[i] = 0;
  }
  
}



void fadeTentacleLed(uint8_t led, uint8_t toVal, uint8_t stepTime) {
  
  Serial << "fade to: " << toVal << endl;
  
  uint8_t skipEvery = 255/abs(ledVals[led]-toVal);
  
  
  for(uint8_t i=0; i<255; i++) {
    
      if(ledVals[led] < toVal) {
        
        if(i <= toVal) {
          if(i % skipEvery == 0) {
            if(led < LEDQTY-2) {
              ShiftPWM.SetOne(led+12, i);
            } else if(led == LEDQTY-2) {
              analogWrite(tailLed1, i);
            } else if(led == LEDQTY-1) {
              analogWrite(tailLed2, i);
            }
          }
        }
        
      } else if(ledVals[led] > toVal) {
         
        if(i <= (255-toVal)) {
          if(i % skipEvery == 0) {
            if(led < LEDQTY-2) {
              ShiftPWM.SetOne(led+12, 255-i);
            } else if(led == LEDQTY-2) {
              analogWrite(tailLed1, 255-i);
            } else if(led == LEDQTY-1) {
              analogWrite(tailLed2, 255-i);
            }
          }
        }
        
      }
    
    delay(stepTime);
    
  }
  

  if(led < LEDQTY-2) {
    ShiftPWM.SetOne(led+12, toVal);
  } else if(led == LEDQTY-2) {
    analogWrite(tailLed1, toVal);
  } else if(led == LEDQTY-1) {
    analogWrite(tailLed2, toVal);
  }
  
  ledVals[led] = toVal;
    
  Serial << "done fade" << endl;
  
}



